
%bcond_with  internet

%global with_phpfpm 1
%global upstream_version     1.6.6

%global roundcubedir %{_datadir}/roundcubemail
%global _logdir /var/log  
Name: roundcubemail
Version:  %{upstream_version}%{?upstream_prever:~%{upstream_prever}}
Release:    1%{?dist}
Summary: Round Cube Webmail is a browser-based multilingual IMAP client

License: GPL-3.0-or-later AND GPL-2.0-only AND LGPL-2.0-or-later AND CC-BY-SA-3.0 AND MIT AND BSD-2-Clause AND BSD-3-Clause AND PHP-3.01
URL: http://www.roundcube.net
Source0: https://github.com/roundcube/roundcubemail/releases/download/%{upstream_version}%{?upstream_prever:-%{upstream_prever}}/roundcubemail-%{upstream_version}%{?upstream_prever:-%{upstream_prever}}-complete.tar.gz
Source8: https://github.com/roundcube/roundcubemail/releases/download/%{upstream_version}%{?upstream_prever:-%{upstream_prever}}/roundcubemail-%{upstream_version}%{?upstream_prever:-%{upstream_prever}}-complete.tar.gz.asc
Source9: https://roundcube.net/download/pubkey.asc

Source1: roundcubemail.httpd
Source3: roundcubemail.nginx
Source2: roundcubemail.logrotate
Source4: roundcubemail-README-rpm.txt
Source5: roundcubemail-bundled.php

Patch1: roundcubemail-1.6-confpath.patch


BuildArch: noarch
BuildRequires: gnupg2
BuildRequires: php(language) >= 7.3
BuildRequires: php-cli

%if %{with_phpfpm}
Requires:  webserver
Requires:  nginx-filesystem
Requires:  httpd-filesystem
Requires:  php(httpd)
%else
Requires: httpd
Requires: mod_php
%endif
Requires: php(language) >= 7.3
Requires: php-ctype
Requires: php-curl
Requires: php-date
Requires: php-dom
Requires: php-fileinfo
Requires: php-filter
Requires: php-gd
Requires: php-hash
Requires: php-iconv
Requires: php-intl
Requires: php-json
Requires: php-ldap
Requires: php-libxml
Requires: php-mbstring
Requires: php-openssl
Requires: php-pcre
Requires: php-pdo
Requires: php-posix
Requires: php-reflection
Requires: php-session
Requires: php-simplexml
Requires: php-sockets
Requires: php-spl
Requires: php-tokenizer
Requires: mailcap
Requires: php-exif
Requires: php-zip

Suggests:   php-uploadprogress
Suggests:   php-sodium
Recommends: php-enchant
Suggests:   php-pspell
Suggests:   php-apcu
Suggests:   php-memcache
Suggests:   php-memcached
Suggests:   php-redis
Suggests:   php-gearman
Suggests:   php-krb5
Suggests:   php-pam

Provides: bundled(js-lessjs) = 3.13.0
Provides: bundled(js-publickey) = 0e011cb1
Provides: bundled(js-openpgp) = 5.0.0
Provides: bundled(js-tinymce) = 5.8.2
Provides: bundled(js-bootstrap) = 4.5.3
Provides: bundled(js-codemirror) = 5.58.3
Provides: bundled(js-jquery) = 3.5.1
Provides: bundled(js-jstimezonedetect) = 1.0.7
Provides: bundled(js-tinymce-langs) = 5.8.2

Provides: bundled(php-pear-auth-sasl) = v1.1.0
Provides: bundled(php-bacon-bacon-qr-code) = 2.0.8
Provides: bundled(php-dasprid-enum) = 1.0.5
Provides: bundled(php-pear-console-getopt) = v1.4.3
Provides: bundled(php-pear-net-sieve) = 1.4.6
Provides: bundled(php-pear-net-smtp) = 1.10.1
Provides: bundled(php-pear-pear-exception) = v1.0.2
Provides: bundled(php-pear-mail-mime) = 1.10.11
Provides: bundled(php-pear-pear-core-minimal) = v1.10.14
Provides: bundled(php-roundcube-rtf-html-php) = v2.2
Provides: bundled(php-kolab-net-ldap3) = v1.1.5
Provides: bundled(php-roundcube-plugin-installer) = 0.3.2
Provides: bundled(php-pear-crypt-gpg) = v1.6.8
Provides: bundled(php-pear-net-ldap2) = v2.3.0
Provides: bundled(php-guzzlehttp-guzzle) = 7.8.1
Provides: bundled(php-guzzlehttp-promises) = 2.0.2
Provides: bundled(php-guzzlehttp-psr7) = 2.6.2
Provides: bundled(php-masterminds-html5) = 2.7.6
Provides: bundled(php-pear-console-commandline) = v1.2.6
Provides: bundled(php-psr-http-client) = 1.0.3
Provides: bundled(php-psr-http-factory) = 1.0.2
Provides: bundled(php-psr-http-message) = 2.0
Provides: bundled(php-ralouphie-getallheaders) = 3.0.3
Provides: bundled(php-symfony-deprecation-contracts) = v2.5.2
Provides: bundled(php-pear-net-socket) = v1.2.2


%description
RoundCube Webmail is a browser-based multilingual IMAP client
with an application-like user interface. It provides full
functionality you expect from an e-mail client, including MIME
support, address book, folder manipulation, message searching
and spell checking. RoundCube Webmail is written in PHP and 
requires a database: MySQL, PostgreSQL and SQLite are known to
work. The user interface is fully skinnable using XHTML and
CSS 2.


%prep
%{?gpgverify: %{gpgverify} --keyring=%{SOURCE9} --signature=%{SOURCE8} --data=%{SOURCE0}}

%setup -q -n roundcubemail-%{upstream_version}%{?upstream_prever:-%{upstream_prever}}
%patch -P1 -p1 -b .rpm

: PHP bundled libraries
php %{SOURCE5} vendor/composer/installed.json

%if %{with internet}
: JS bundled libraries
php %{SOURCE5} https://raw.githubusercontent.com/roundcube/roundcubemail/%{upstream_version}%{?upstream_prever:-%{upstream_prever}}/jsdeps.json
%endif

find . -type f -print | xargs chmod a-x
find . -name \.htaccess -delete -print

find . -type f -name '*.orig' -o -name '*.rpm' -exec rm {} \; -print

echo "CVE-2012-4230: removing tinymce bbcode plugin, check path if this fails."
test -d program/js/*mce/plugins/bbcode && rm -rf program/js/*mce/plugins/bbcode || exit 1


%build


%install
install -d %{buildroot}%{roundcubedir}
cp -pr * %{buildroot}%{roundcubedir}

install -Dpm 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/httpd/conf.d/%{name}.conf

%if %{with_phpfpm}
install -Dpm 0644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/nginx/default.d/%{name}.conf
%endif

mkdir -p %{buildroot}%{_sysconfdir}/roundcubemail
install -pDm644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/roundcubemail

mkdir -p %{buildroot}/var/log/roundcubemail
mkdir -p %{buildroot}/var/lib/roundcubemail/temp
mkdir -p %{buildroot}/var/lib/roundcubemail/enigma

cp -pr %SOURCE4 README-rpm.txt

touch %{buildroot}%{_sysconfdir}/roundcubemail/db.inc.php
touch %{buildroot}%{_sysconfdir}/roundcubemail/main.inc.php
touch %{buildroot}%{_sysconfdir}/roundcubemail/config.inc.php

mv %{buildroot}%{roundcubedir}/config/* %{buildroot}%{_sysconfdir}/roundcubemail/

pushd %{buildroot}%{roundcubedir}/plugins
for plug in $(ls); do
  if [ -f $plug/config.inc.php.dist ]; then
    mv $plug/config.inc.php.dist %{buildroot}%{_sysconfdir}/roundcubemail/$plug.inc.php.dist
  fi
  if [ -d $plug/tests ]; then
    rm -r $plug/tests
  fi
done
popd

rm -r %{buildroot}%{roundcubedir}/{config,logs,temp}
rm -r %{buildroot}%{roundcubedir}/{CHANGELOG.md,INSTALL,LICENSE,README.md,UPGRADING}
rm    %{buildroot}%{roundcubedir}/composer.json-dist


%check
: Check our autoloader for needed classes
php -r '
require "%{buildroot}%{roundcubedir}/vendor/autoload.php";
$cl = [ "Auth_SASL", "Crypt_GPG", "Mail_mime", "Net_LDAP2", "Masterminds\\HTML5", "GuzzleHttp\\Client",
        "Net_LDAP3", "Net_Sieve", "Net_SMTP", "PEAR" , "BaconQrCode\\Writer", "RtfHtmlPhp\\Document" ];
$ret = 0;
foreach ($cl as $c) {
  if (class_exists($c)) {
    echo "$c ok\n";
  } else {
    echo("$c is missing\n");
    $ret = 1;
  }
}
exit($ret);
'

%pre
if [ -f %{_sysconfdir}/%{name}/main.inc.php ]; then
  sed -e "/'temp_dir'/d" \
      -e "/'mime_types'/d" \
      -e "/'log_dir'/d" \
      -i %{_sysconfdir}/%{name}/main.inc.php
fi


%files
%license LICENSE
%doc CHANGELOG.md INSTALL README.md UPGRADING README-rpm.txt
%doc composer.json-dist
%{roundcubedir}
%dir %{_sysconfdir}/%{name}
%ghost %attr(0640,root,apache) %config(noreplace) %{_sysconfdir}/%{name}/db.inc.php
%ghost %attr(0640,root,apache) %config(noreplace) %{_sysconfdir}/%{name}/main.inc.php
%ghost %attr(0640,root,apache) %config(noreplace) %{_sysconfdir}/%{name}/config.inc.php
%attr(0640,root,apache) %{_sysconfdir}/%{name}/mimetypes.php
%attr(0640,root,apache) %{_sysconfdir}/%{name}/defaults.inc.php
%attr(0640,root,apache) %{_sysconfdir}/%{name}/config.inc.php.sample
%attr(0640,root,apache) %{_sysconfdir}/%{name}/*.inc.php.dist
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%if %{with_phpfpm}
%config(noreplace) %{_sysconfdir}/nginx/default.d/%{name}.conf
%endif
%attr(0770,root,apache) %dir /var/log/roundcubemail
%attr(0770,root,apache) %dir /var/lib/roundcubemail
%attr(0770,root,apache) %dir /var/lib/roundcubemail/temp
%attr(0770,root,apache) %dir /var/lib/roundcubemail/enigma
%config(noreplace) %{_sysconfdir}/logrotate.d/roundcubemail


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.6.6-1
- initial build
